#ifndef _SANITYCHECK_H_
#define _SANITYCHECK_H_

#ifndef PCB_REV
    #error "You must define PCB_REV"
#else
    #if PCB_REV < 1 || PCB_REV > 4
        #error "Unsupported PCB-Revision"
    #endif

    #if PCB_REV < 3 && defined(FEATURE_ENABLE_CAN)
        #error "CAN-Feature unsupported with this PCB-Rev"
    #endif
    #if PCB_REV < 4 && defined(DFEATURE_ENABLE_GPS)
        #error "GPS-Feature unsupported with this PCB-Rev"
    #endif
#endif

#ifdef CAN_DEBUG_MESSAGE
    #ifndef FEATURE_ENABLE_CAN
        #error "You cannot enable CAN-Debug-Message without FEATURE_ENABLE_CAN"
    #endif
#endif

#ifndef ADMIN_PASSWORD
    #error "You need to define ADMIN_PASSWORD for OTA-Update"
#endif

#ifdef FEATURE_ENABLE_WIFI_CLIENT
    #ifndef WIFI_PASSWORD_CLIENT
        #error "You must define an WIFI_PASSWORD for Client-Mode"
    #endif

    #ifndef WIFI_SSID_CLIENT
        #error "You must define an WIFI_SSID for Client-Mode"
    #endif
#endif

#ifndef WIFI_AP_PASSWORD
#error "You must define an WIFI_AP_PASSWORD for Standalone AP-Mode"
#endif

#endif //_SANITYCHECK_H_